
CREATE TABLE IF NOT EXISTS `#__sc_config` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `keyword` varchar(32) NOT NULL,
  `description` varchar(255) NOT NULL,
  `setting` text NOT NULL,
  `cfgset` int(11) NOT NULL DEFAULT '0',
  `type` enum('text','textarea','richtext','yesno','list') NOT NULL,
  `indopts` text NOT NULL,
  `sh` int(11) NOT NULL,
  `sv` int(11) NOT NULL,
  `pagename` varchar(32) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `kw` (`keyword`)
);

CREATE TABLE IF NOT EXISTS `#__sc_fields` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(32) NULL,
  `caption` varchar(32) NULL,
  `type` varchar(16) NULL,
  `length` int(11) NULL,
  `classname` varchar(64)  NULL,
  `required` int(11) NULL,
  `ordering` int(11) NULL,
  `published` int(11) NULL,
  `checkfunction` varchar(64) NULL,
  `fieldcontents` text NULL,
  PRIMARY KEY (`id`)
);

CREATE TABLE IF NOT EXISTS `#__sc_odetails` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `orderid` int(11) NULL,
  `prodcode` varchar(10)  NULL,
  `qty` int(11)  NULL,
  `unitprice` float  NULL,
  `total` float  NULL,
  `shorttext` varchar(255)  NULL,
  `option` varchar(32)  NULL,
  PRIMARY KEY (`id`)
);

CREATE TABLE IF NOT EXISTS `#__sc_orders` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255)  NULL,
  `email` varchar(255)  NULL,
  `address` text  NULL,
  `codepostal` varchar(15)  NULL,
  `city` varchar(32)  NULL,
  `telephone` varchar(32)  NULL,
  `ordercode` varchar(16)  NULL,
  `ipaddress` varchar(16)  NULL,
  `customfields` text  NULL,
  `orderdt` int(11)  NULL,
  `total` float  NULL,
  `status` varchar(16)  NULL,
  `tax` float  NULL,
  `archive` int(11)  NULL,
  `shipCost` varchar(10)  NULL,
  `shipRegion` varchar(255)  NULL,
  PRIMARY KEY (`id`)
);

CREATE TABLE IF NOT EXISTS `#__sc_products` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `prodcode` varchar(13)  NULL,
  `shorttext` varchar(255)  NULL,
  `av_qty` int(11)  NULL,
  `unitprice` float  NULL,
  `published` int(11)  NULL,
  `optionstitle` varchar(32)  NULL,
  `options` text  NULL,
  `showas` int(11)  NULL,
  `category` varchar(255)  NULL,
  `shippoints` varchar(10)  NULL,
  PRIMARY KEY (`id`)
);

CREATE TABLE IF NOT EXISTS `#__sc_ship_zones` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `name` varchar(100)  NULL,
  `points_lower` float  NULL,
  `price` varchar(100)  NULL,
  `points_upper` float  NULL,
  PRIMARY KEY (`id`)
);

CREATE TABLE IF NOT EXISTS `#__sc_vouchers` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255)  NULL,
  `formula` varchar(255)  NULL,	
  `avqty` int(11)  NULL,
  `qtylimited` int(11)  NULL,
  `validfrom` int(11)  NULL,
  `validto` int(11)  NULL,
  `datelimited` int(11)  NULL,
  `published` int(11)  NULL,
  `lot` varchar(32)  NULL,
  PRIMARY KEY (`id`)
);

INSERT IGNORE INTO `#__sc_config` VALUES(1, 'currency', 'Currency symbol', 'CAD', 0, 'text', '', 0, 0, 'Finance');
INSERT IGNORE INTO `#__sc_config` VALUES(2, 'show_emptycart', 'Show Empty Cart button', '1', 0, 'yesno', '', 0, 0, 'Frontend Display');
INSERT IGNORE INTO `#__sc_config` VALUES(3, 'thousand_sep', 'Thousands separator', ',', 0, 'text', '', 0, 0, 'Frontend Display');
INSERT IGNORE INTO `#__sc_config` VALUES(4, 'decimal_sep', 'Decimal separator', '.', 0, 'text', '', 0, 0, 'Frontend Display');
INSERT IGNORE INTO `#__sc_config` VALUES(5, 'decimals', 'Number of decimals', '2', 0, 'text', '', 0, 0, 'Frontend Display');
INSERT IGNORE INTO `#__sc_config` VALUES(6, 'remove_button', 'Show remove button', '1', 0, 'yesno', '', 0, 0, 'Frontend Display');
INSERT IGNORE INTO `#__sc_config` VALUES(7, 'email_customer', 'Send confirmation email to customer', '1', 0, 'yesno', '', 0, 0, 'Communication');
INSERT IGNORE INTO `#__sc_config` VALUES(8, 'email_copies', 'Send confirmation email COPIES to', 'me@mysite.com\r\nyou@mysite.com', 0, 'textarea', '', 40, 10, 'Communication');
INSERT IGNORE INTO `#__sc_config` VALUES(9, 'curralign', 'Currency symbol position', '0', 0, 'list', 'Before amount:1\r\nAfter amount:0', 0, 0, 'Frontend Display');
INSERT IGNORE INTO `#__sc_config` VALUES(10, 'ostatus', 'Order statuses (one per line)', 'New\r\nReviewed\r\nReview\r\nCancelled\r\nTreated\r\nArchive', 0, 'textarea', '', 20, 10, 'Order statuses');
INSERT IGNORE INTO `#__sc_config` VALUES(11, 'taxrate', 'Tax rate to apply (VAT/PDV/BTW etc)', '0', 0, 'text', '', 0, 0, 'Finance');
INSERT IGNORE INTO `#__sc_config` VALUES(12, 'emailhtml', 'Email is in HTML format', '0', 0, 'yesno', '', 0, 0, 'Communication');
INSERT IGNORE INTO `#__sc_config` VALUES(13, 'dateformat', 'Date format', 'd-m-y', 0, 'text', '', 0, 0, 'Frontend Display');
INSERT IGNORE INTO `#__sc_config` VALUES(14, 'timeformat', 'Time format', 'h:i:s', 0, 'text', '', 0, 0, 'Frontend Display');
INSERT IGNORE INTO `#__sc_config` VALUES(15, 'reselleremail', 'Reseller email for PayPal', 'change@me.com', 0, 'text', '', 40, 0, 'PayPal');
INSERT IGNORE INTO `#__sc_config` VALUES(16, 'usepaypal', 'Use PayPal for checkout', '1', 0, 'yesno', '', 0, 0, 'PayPal');
INSERT IGNORE INTO `#__sc_config` VALUES(17, 'paypalcurrency', 'PayPal currency', 'CAD', 0, 'list', 'Australian Dollars (AUD):AUD \r\nCanadian Dollars (CAD):CAD \r\nEuros (EUR):EUR \r\nPounds Sterling (GBP):GBP \r\nYen (YEN):JPY \r\nU.S. Dollars (USD):USD \r\nNew Zealand Dollar (NZD):NZD \r\nSwiss Franc:CHF \r\nHong Kong Dollar (HKD):HKD \r\nSingapore Dollar (SGD):SGD \r\nSwedish Krona:SEK \r\nDanish Krone:DKK \r\nPolish Zloty:PLN \r\nNorwegian Krone:NOK \r\nHungarian Forint:HUF \r\nCzech Koruna:CZK \r\nMexican Pesos:MXN \r\nSouth African Rand:R', 0, 0, 'PayPal');
INSERT IGNORE INTO `#__sc_config` VALUES(18, 'usecidasemail', 'Use content as email', '0', 0, 'yesno', '', 0, 0, 'Communication');
INSERT IGNORE INTO `#__sc_config` VALUES(19, 'usestdproduct', 'Use the Systematic Product', '0', 0, 'yesno', '', 10, 0, 'Finance');
INSERT IGNORE INTO `#__sc_config` VALUES(20, 'emailcid', 'Confirmation content ID', '0', 0, 'text', '', 3, 0, 'Communication');
INSERT IGNORE INTO `#__sc_config` VALUES(21, 'cart_fee_product', 'Systematic Product (code) to add to cart', 'extracost', 0, 'text', '', 10, 0, 'Finance');
INSERT IGNORE INTO `#__sc_config` VALUES(22, 'prodcats', 'Product categories (one per line)', 'Food\r\nDrinks\r\nPlants\r\nChemistry\r\nNon-Food', 0, 'textarea', '', 40, 5, 'Product categories');
INSERT IGNORE INTO `#__sc_config` VALUES(23, 'ppreturnsuccess', 'PayPal Success return url', '', 0, 'text', '', 80, 0, 'PayPal');
INSERT IGNORE INTO `#__sc_config` VALUES(24, 'ppreturncancel', 'PayPal Failure/Cancel return url', '', 0, 'text', '', 80, 0, 'PayPal');
INSERT IGNORE INTO `#__sc_config` VALUES(25, 'pgclassname', 'Payment gateway classname', 'scpaypal', 0, 'text', '', 0, 0, 'Payment gateway');
INSERT IGNORE INTO `#__sc_config` VALUES(26, 'mailengine', 'Mail engine', 'joomla', 0, 'list', 'Joomla:joomla\r\nAlternative:alternative', 0, 0, 'Communication');
INSERT IGNORE INTO `#__sc_config` VALUES(27, 'shippingenabled', 'If Enabled, Shipping Addon will be used to calculate Shipping Cost', '0', 0, 'yesno', '', 0, 0, 'Shipping');
INSERT IGNORE INTO `#__sc_config` VALUES(28, 'checkminqty', 'Check minimum quantity in DB', '0', 0, 'yesno', '', 0, 0, 'Checking out');
INSERT IGNORE INTO `#__sc_config` VALUES(29, 'mincheckout', 'Minimum AMOUNT For checkout', '0', 0, 'text', '', 0, 0, 'Checking out');
INSERT IGNORE INTO `#__sc_config` VALUES(30, 'usevouchers', 'Use the vouchers?', '0', 0, 'yesno', '', 0, 0, 'Checking out');
INSERT IGNORE INTO `#__sc_config` VALUES(31, 'pretextid', 'Content ID above cart display', '0', 0, 'text', '', 0, 0, 'Frontend Display');
INSERT IGNORE INTO `#__sc_config` VALUES(32, 'posttextid', 'Content ID below cart display', '0', 0, 'text', '', 0, 0, 'Frontend Display');

